itpp::binfile_details::Ifstream_Binfile_Facade Class Reference
Base Module » IT++ File Format

Ifstream Interface Facade for Binary Streams. More...

`#include <itpp/base/binfile.h>`

Inheritance diagram for itpp::binfile_details::Ifstream_Binfile_Facade:

## Public Member Functions

| Ifstream_Binfile_Facade ()
| Default Constructor.
| Ifstream_Binfile_Facade (const char *filename, std::ios_base::openmode mode=std::ios_base::in|std::ios_base::binary)
| Constructor from filename and stream mode.
bool | is_open ()
| Open state.
void | open (const char *filename, std::ios_base::openmode mode=std::ios_base::in|std::ios_base::binary)
| Method to open corresponding file.
void | close ()
| Method to close corresponding file.
std::streamsize | gcount () const
| Last extracted chars count.
int | get ()
| Get single char.
Ifstream_Binfile_Facade & | get (char &c)
| Get single char.
Ifstream_Binfile_Facade & | get (char *s, std::streamsize n)
| Get multiple chars to c-string and add trailing 0.
Ifstream_Binfile_Facade & | get (char *s, std::streamsize n, char delim)
| Get multiple chars to c-string without trailing 0.
Ifstream_Binfile_Facade & | getline (char *s, std::streamsize n)
| Get multiple chars to c-string without trailing 0.
Ifstream_Binfile_Facade & | getline (char *s, std::streamsize n, char delim)
Ifstream_Binfile_Facade & | ignore (std::streamsize n=1, int delim=EOF)
| Extract and ignore chars.
int | peek ()
| Peak single char from the top of the buffer.
Ifstream_Binfile_Facade & | read (char *s, std::streamsize n)
| Read n chars from stream.
std::streamsize | readsome (char *s, std::streamsize n)
| Read up to n available chars from stream.
Ifstream_Binfile_Facade & | putback (char c)
| This method attempts to put back single char.
Ifstream_Binfile_Facade & | unget ()
| Unget last extracted char.
std::streampos | tellg ()
| Get position.
Ifstream_Binfile_Facade & | seekg (std::streampos pos)
| Set position.
Ifstream_Binfile_Facade & | seekg (std::streamoff pos, std::ios_base::seekdir way)
| Set relative position.
bool | good () const
| This method returns true is stream state is good.
bool | eof () const
| This method returns true if eof is reached.
bool | fail () const
| This method returns true if either failbit or badbit is set.
bool | bad () const
| This method returns true if badbit is set.
bool | operator! () const
| Unary not operator to check the stream state.
| operator bool () const
| Conversion to bool to validate stream state.
std::ios_base::iostate | rdstate () const
| Method to read stream state flags.
void | setstate (std::ios_base::iostate state)
| Method to set the stream state (combines already set flags with flags provide by user).
void | clear (std::ios_base::iostate state=std::ios_base::goodbit)
| Method to set stream state (overwrites stream state flags).
std::ios_base::iostate | exceptions () const
| Method to get the exceptions mask.
void | exceptions (std::ios_base::iostate except)
| Method to set the exceptions mask.
virtual | ~Ifstream_Binfile_Facade ()
| Destructor.

## Protected Member Functions

std::ifstream * | stream ()
| Access to internal stream for derived classes.

## Detailed Description

Ifstream Interface Facade for Binary Streams.

This class implements std::ofstream facade to make ITPP binary file streams exportable from dll. This facade implements basic functionality only. It does not provide an access to the following stream facilities (all of them are useless for binary streams)

1. locale(imbue) It does not make sence to change locale settings for binary streams. Changes in formatting or char conversion can result in compatibility problems with resulting binary files
2. stream buffer (rdbuf). DLL and application can use different versions of runtime , so it would be dangerous to use buffer created in DLL in application context
3. stream extraction operators. It is assumed that stream extraction is defined in binary stream classes derived from this class
4. formatting interface (copyfmt, fill, narrow, widen). This is not relevant to binary streams
5. ios_base-related stuff. These things are excluded since they provide unnecessarily formatting facilities.

Definition at line 240 of file binfile.h.

## Constructor & Destructor Documentation

## Ifstream_Binfile_Facade() [1/2]

itpp::binfile_details::Ifstream_Binfile_Facade::Ifstream_Binfile_Facade | ( |  | ) |

Default Constructor.

Definition at line 54 of file binfile.cpp.

## Ifstream_Binfile_Facade() [2/2]

itpp::binfile_details::Ifstream_Binfile_Facade::Ifstream_Binfile_Facade | ( | const char * | filename,
|  | std::ios_base::openmode | mode = std::ios_base::in | std::ios_base::binary )

explicit

Constructor from filename and stream mode.

Definition at line 56 of file binfile.cpp.

## ~Ifstream_Binfile_Facade()

itpp::binfile_details::Ifstream_Binfile_Facade::~Ifstream_Binfile_Facade | ( |  | ) |

virtual

Destructor.

Definition at line 59 of file binfile.cpp.

## Member Function Documentation

## is_open()

bool itpp::binfile_details::Ifstream_Binfile_Facade::is_open | ( |  | ) |

inline

Open state.

Definition at line 253 of file binfile.h.

## open()

void itpp::binfile_details::Ifstream_Binfile_Facade::open | ( | const char * | filename,
|  | std::ios_base::openmode | mode = std::ios_base::in | std::ios_base::binary )

inline

Method to open corresponding file.

Definition at line 256 of file binfile.h.

Referenced by itpp::bifstream::open().

## close()

void itpp::binfile_details::Ifstream_Binfile_Facade::close | ( |  | ) |

inline

Method to close corresponding file.

Definition at line 260 of file binfile.h.

## gcount()

std::streamsize itpp::binfile_details::Ifstream_Binfile_Facade::gcount | ( |  | ) | const

inline

Last extracted chars count.

Definition at line 262 of file binfile.h.

## get() [1/4]

int itpp::binfile_details::Ifstream_Binfile_Facade::get | ( |  | ) |

inline

Get single char.

Definition at line 264 of file binfile.h.

Referenced by get(), get(), get(), itpp::bifstream::operator>>(), itpp::bifstream::operator>>(), and itpp::bifstream::operator>>().

## get() [2/4]

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::get | ( | char & | c | ) |

inline

Get single char.

Definition at line 266 of file binfile.h.

References get().

## get() [3/4]

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::get | ( | char * | s,
|  | std::streamsize | n )

inline

Get multiple chars to c-string and add trailing 0.

Definition at line 268 of file binfile.h.

References get().

## get() [4/4]

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::get | ( | char * | s,
|  | std::streamsize | n,
|  | char | delim )

inline

Get multiple chars to c-string without trailing 0.

Definition at line 271 of file binfile.h.

References get().

## getline() [1/2]

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::getline | ( | char * | s,
|  | std::streamsize | n )

inline

Get multiple chars to c-string without trailing 0.

Definition at line 274 of file binfile.h.

References getline().

Referenced by getline(), and itpp::bifstream::operator>>().

## getline() [2/2]

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::getline | ( | char * | s,
|  | std::streamsize | n,
|  | char | delim )

inline

Definition at line 276 of file binfile.h.

## ignore()

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::ignore | ( | std::streamsize | n = 1,
|  | int | delim = EOF )

inline

Extract and ignore chars.

Definition at line 279 of file binfile.h.

References ignore().

Referenced by ignore().

## peek()

int itpp::binfile_details::Ifstream_Binfile_Facade::peek | ( |  | ) |

inline

Peak single char from the top of the buffer.

Definition at line 282 of file binfile.h.

## read()

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::read | ( | char * | s,
|  | std::streamsize | n )

inline

Read n chars from stream.

Definition at line 284 of file binfile.h.

References read().

Referenced by read().

## readsome()

std::streamsize itpp::binfile_details::Ifstream_Binfile_Facade::readsome | ( | char * | s,
|  | std::streamsize | n )

inline

Read up to n available chars from stream.

Definition at line 287 of file binfile.h.

## putback()

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::putback | ( | char | c | ) |

inline

This method attempts to put back single char.

Definition at line 290 of file binfile.h.

References putback().

Referenced by putback().

## unget()

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::unget | ( |  | ) |

inline

Unget last extracted char.

Definition at line 293 of file binfile.h.

References unget().

Referenced by unget().

## tellg()

std::streampos itpp::binfile_details::Ifstream_Binfile_Facade::tellg | ( |  | ) |

inline

Get position.

Definition at line 295 of file binfile.h.

Referenced by itpp::bifstream::length().

## seekg() [1/2]

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::seekg | ( | std::streampos | pos | ) |

inline

Set position.

Definition at line 297 of file binfile.h.

References seekg().

Referenced by itpp::bifstream::length(), seekg(), and seekg().

## seekg() [2/2]

Ifstream_Binfile_Facade & itpp::binfile_details::Ifstream_Binfile_Facade::seekg | ( | std::streamoff | pos,
|  | std::ios_base::seekdir | way )

inline

Set relative position.

Definition at line 300 of file binfile.h.

References seekg().

## good()

bool itpp::binfile_details::Ifstream_Binfile_Facade::good | ( |  | ) | const

inline

This method returns true is stream state is good.

Definition at line 304 of file binfile.h.

## eof()

bool itpp::binfile_details::Ifstream_Binfile_Facade::eof | ( |  | ) | const

inline

This method returns true if eof is reached.

Definition at line 306 of file binfile.h.

## fail()

bool itpp::binfile_details::Ifstream_Binfile_Facade::fail | ( |  | ) | const

inline

This method returns true if either failbit or badbit is set.

Definition at line 308 of file binfile.h.

## bad()

bool itpp::binfile_details::Ifstream_Binfile_Facade::bad | ( |  | ) | const

inline

This method returns true if badbit is set.

Definition at line 310 of file binfile.h.

## operator!()

bool itpp::binfile_details::Ifstream_Binfile_Facade::operator! | ( |  | ) | const

inline

Unary not operator to check the stream state.

Definition at line 313 of file binfile.h.

## operator bool()

itpp::binfile_details::Ifstream_Binfile_Facade::operator bool | ( |  | ) | const

inline

Conversion to bool to validate stream state.

Definition at line 315 of file binfile.h.

## rdstate()

std::ios_base::iostate itpp::binfile_details::Ifstream_Binfile_Facade::rdstate | ( |  | ) | const

inline

Method to read stream state flags.

Definition at line 318 of file binfile.h.

## setstate()

void itpp::binfile_details::Ifstream_Binfile_Facade::setstate | ( | std::ios_base::iostate | state | ) |

inline

Method to set the stream state (combines already set flags with flags provide by user).

Definition at line 320 of file binfile.h.

## clear()

void itpp::binfile_details::Ifstream_Binfile_Facade::clear | ( | std::ios_base::iostate | state = std::ios_base::goodbit | ) |

inline

Method to set stream state (overwrites stream state flags).

Definition at line 322 of file binfile.h.

## exceptions() [1/2]

std::ios_base::iostate itpp::binfile_details::Ifstream_Binfile_Facade::exceptions | ( |  | ) | const

inline

Method to get the exceptions mask.

Definition at line 324 of file binfile.h.

## exceptions() [2/2]

void itpp::binfile_details::Ifstream_Binfile_Facade::exceptions | ( | std::ios_base::iostate | except | ) |

inline

Method to set the exceptions mask.

Definition at line 326 of file binfile.h.

## stream()

std::ifstream * itpp::binfile_details::Ifstream_Binfile_Facade::stream | ( |  | ) |

inline protected

Access to internal stream for derived classes.

Definition at line 332 of file binfile.h.

Referenced by itpp::bifstream::operator>>().

The documentation for this class was generated from the following files:

- itpp/base/binfile.h
- itpp/base/binfile.cpp

Generated on for IT++ by Doxygen 1.15.0